# Example asdf:make-build of CFFI dependency

This sample creates a program that calls a shared library written in C from Lisp as a binary executable by asdf: make-build.

First, create a shared library. mylib.c defines a function called normal_plus that performs simple addition.

```c
int
normal_plus (int n1, int n2)
{
  return n1 + n2;
}
```

```
$ cd lib
$ gcc -fpic -shared mylib.c -p mylib.so
```

This created a shared library named mylib.soIn ECL, you can use the package called CFFI to call the functions of the shared library.

```common-lisp
> (ql:quickload :cffi)
```

The code in this repository assumes that the cffi package has been previously installed on the system by Quicklisp or other means.


In "example.lisp", the lib directory is registered in * foreign-library-directories *. This is to tell CFFI where to look for shared libraries.
Load-foregin-library actually loads the shared library named mylib.

```common-lisp
(pushnew (merge-pathnames #P"lib/" *default-pathname-defaults*) cffi:*foreign-library-directories*)
(cffi:define-foreign-library mylib
    (t (:default "mylib")))
(cffi:load-foreign-library 'mylib)
```


foreign-funcall calls a C function.
```common-lisp
(defun test-function ()
   (print (cffi:foreign-funcall "normal_plus" :int 10 :int 20 :int)))
```

Write asdf and cffi in dependencies.

```common-lisp
(asdf:defsystem #:example-with-dep
    :serial t
    :depends-on (#:asdf #:cffi)
    :components ((:file "package")
                 (:file "example")))
```

Executable file is generated by inputting the following command on REPL.

```common-lisp
CL-USER> (asdf:load-system :example-with-dep)
```

```common-lisp
CL-USER> (asdf:make-build :example-with-dep
                          :type :program
                          :move-here #P"./"
                          :epilogue-code '(progn
                                           (example:test-function)
                                           (si:exit)))
```
